## kupfer 0%2Bv208

=== help/Makefile ===
#  This makefile is for convenience.
#
#  Run 'make' to build HTML documentation in the C directory
#  Run 'make $LANG' to update the translation file for language $LANG
#
#  To add a new language, edit Makefile.am

include Makefile.am


all:
	make -C C

$(DOC_LINGUAS): C/*.page
	xml2po -mmallard -u "$@/$@.po" C/*.page

=== debian/changelog ===
kupfer (0+v208-6) unstable; urgency=medium

  * Team upload.
  * Update debian/patches/keyring-3.patch to work with modern versions of
    Keyring (use public API where possible instead of relying on internals).

 -- Dmitry Shachnev <mitya57@debian.org>  Thu, 25 Feb 2016 21:24:45 +0300

kupfer (0+v208-5) unstable; urgency=medium

  * debian/patches/bookmarks-places.sqlite.patch:
    - Fix the error when reading firefox bookmark files (Closes: #749067). 

 -- Hugo Lefeuvre <hugo6390@orange.fr>  Sat, 07 Jun 2014 16:16:36 +0200

kupfer (0+v208-4) unstable; urgency=low

  * debian/control:
    - New Maintainer and co-maintainer (Closes: #741022),
        PAPT as maintainer,
        Hugo Lefeuvre as uploader.
    - Changed kupfer's source webpage: The link was dead.
  * debian/copyright:
    - Changed kupfer's source webpage: The link was dead.
    - New copyright line for the new maintainer.

 -- Hugo Lefeuvre <hugo6390@orange.fr>  Wed, 21 May 2014 15:57:00 +0200

kupfer (0+v208-3) unstable; urgency=medium

  * Acknowledge NMU, thanks Sebastian!
  * debian/patches/dbus.patch:
    - Fix crash by initializing D-Bus (Closes: #717105) (LP: #1038434).
  * debian/patches/help.patch:
    - Workaround missing xml file, which prevents documentation from
      being loaded (Closes: #679296).
  * debian/patches/locales.patch:
    - Fix crash with locales not supporting dot as decimal point
      separator (Closes: #680008).
  * debian/patches/tracker-needle.patch:
    - Spawn tracker-needle instead of tracker-search-tool (Closes: #680003).
  * debian/control:
    - Use canonical URIs for Vcs-* fields.
    - Bump Standards-Version to 3.9.5.
  * debian/watch:
    - Adjust watch file to point to GitHub.

 -- Luca Falavigna <dktrkranz@debian.org>  Thu, 19 Dec 2013 21:23:22 +0100

kupfer (0+v208-2.1) unstable; urgency=low

  * Non-maintainer upload with maintainer approval.
  * debian/patches/keyring-3.patch: python-keyring dropped support for
    deprecated keyring.backend. Make kupfer compatible with the new backend
    location. (Closes: #728468)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 05 Dec 2013 21:04:54 +0100

kupfer (0+v208-2) unstable; urgency=low

  * debian/patches/uses_fragment.patch:
    - Do not die if urlparse doesn't have uses_fragment method anymore,
      recent Python versions dropped it (Closes: #678580).

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 24 Jun 2012 12:34:02 +0200

kupfer (0+v208-1) unstable; urgency=low

  * New upstream release.

 -- Luca Falavigna <dktrkranz@debian.org>  Mon, 11 Jun 2012 22:51:14 +0200

kupfer (0+v207-2) unstable; urgency=low

  * debian/compat:
    - Bump compatibility level to 9.
  * debian/rules:
    - Remove autogenerated files during clean phase (Closes: #671316).
  * debian/source.lintian-overrides:
    - No longer needed, lintian bug has been fixed.

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 27 May 2012 11:46:08 +0200

kupfer (0+v207-1) unstable; urgency=low

  * New upstream release.
    - waf script is now provided unpacked.
  * debian/control:
    - Bump Standards-Version to 3.9.3.
  * debian/copyright:
    - Update new copyright information.
  * debian/source.lintian-overrides:
    - Override source-contains-waf-binary tag, waf script available in
      the tarball is actually the waf-light one.
  * debian/rules:
    - get-orig-source target is no longer needed.
  * debian/watch:
    - Adjust watch file to fetch xz tarballs.

 -- Luca Falavigna <dktrkranz@debian.org>  Thu, 01 Mar 2012 23:17:02 +0100

kupfer (0+v206+dfsg-1) unstable; urgency=low

  * Upstream tarball repacked to provide unpacked waf (Closes: #654480).
  * debian/patches/rhythmbox.patch:
    - Dropped, no longer useful: rhythmbox-client has been restored.
  * debian/control:
    - Suggest python-qrencode, required by QR module (Closes: #653541).
  * debian/rules:
    - Remove .pyc files on clean.
    - Implement a get-orig-source target to repack upstream tarball.
  * debian/watch:
    - Fix watch file to strip "+dfsg" suffix.

 -- Luca Falavigna <dktrkranz@debian.org>  Tue, 10 Jan 2012 22:31:40 +0100

kupfer (0+v206-2) unstable; urgency=low

  * debian/patches/rhythmbox.patch:
    - rhythmbox-client has been temporarily removed upstream, kupfer
      plugin is no longer able to process playlist. Work-around this by
      invoking dbus-send utility directly.
  * debian/control:
    - Drop python-nautilus from Suggests.
  * debian/rules:
    - Pass --no-install-nautilus-extension to waf to avoid installing
      nautilus extension, it needs to be ported to PyGI in order to work
      with nautilus 3.x (Closes: #645857) (LP: #859104).

 -- Luca Falavigna <dktrkranz@debian.org>  Wed, 19 Oct 2011 22:42:38 +0200

kupfer (0+v206-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Move python-keyring to Recommends.
    - Drop python-gnome2, and python-keyring-gnome from Recommends.
    - Add python-gdata to Suggests.
    - Bump Standards-Version to 3.9.2, no changes required.
  * debian/copyright:
    - Update new copyright information.
  * debian/doc-base, debian/docs:
    - Update to new names and locations.
  * debian/rules:
    - Update to new documentation framework.

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 17 Apr 2011 10:58:15 +0200

kupfer (0+v204-1) unstable; urgency=low

  * New upstream release.
    - Use INT64 signal parameter type (Closes: #615060).
  * debian/patches/debian_path.patch:
    - Removed, obsolete
  * debian/patches/evolution_contacts.patch:
    - Dropped, applied upstream.
  * debian/control:
    - Build-depend on gnome-doc-utils to allow installation of
      help files (Closes: #618499).
  * debian/rules
    - Install kupfer-activate.sh alias.

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 20 Mar 2011 18:00:52 +0100

kupfer (0+v203-2) unstable; urgency=low

  * Upload to unstable.
  * Switch to dh_python2.
  * debian/copyright:
    - Update copyright years.



## kupfer 0%2Bv319

=== debian/changelog ===
kupfer (0+v319-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces
  * d/control: Remove ancient X-Python3-Version field

  [ Hugo Lefeuvre ]
  * debian/control:
    - Bump Standards-Version to 4.1.5.
    - Depend on debhelper >= 11 instead of >= 10.
    - Update Vcs-* fields for Salsa migration.
  * Bump compat from 10 to 11.
  * debian/copyright:
    - Update copyright years.
    - Use HTTPS protocol in d/copyright urls.

 -- Hugo Lefeuvre <hle@debian.org>  Tue, 31 Jul 2018 20:22:19 +0800

kupfer (0+v319-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/control:
    - Bump Standards-Version to 4.1.0.
    - Add missing dh-python Build-Dependency.
  * debian/rules:
    - Build and install documentation in dh_installdocs instead of
      dh_auto_install.

 -- Hugo Lefeuvre <hle@debian.org>  Sun, 24 Sep 2017 18:26:06 +0200

kupfer (0+v319-1) experimental; urgency=low

  * New upstream release (Closes: #854297).
    - Port to Python 3.
    - Port to GTK+3 (Closes: #827350)
    - Support MATE (Closes: #778313).
    - Fix support of Firefox bookmarks (Closes: #787094).
  * Bump compatibility level to 10.
  * debian/control, debian/copyright:
    - Update Hugo Lefeuvre's e-mail address.
  * debian/control:
    - Bump Standards-Version to 3.9.8.
    - Bump debhelper Build-Dependency to (>= 10).
    - Update all Build-Dependencies and Dependencies to match new upstream
      version (Closes: #844153).
    - Update Homepage field.
    - Use HTTPS protocol in Vcs-Browser field.
    - Remove useless X-Python-Version field and add X-Python3-Version.
  * debian/copyright:
    - Remove copyright fields for files that are no longer present.
    - Update Source field to match new website.
    - Update copyright years.
    - Use HTTPS protocol in Format field.
  * debian/rules:
    - don't pass --no-install-nautilus-extension to waf script anymore since
      kupfer has been ported to GTK+3 and pyGI.
  * Remove debian/menu (useless because of provided .desktop files).
  * debian/patches:
    - Drop all patches, either integrated by upstream or deprecated.
    - Add debian/patches/fix-desktop-file.patch.
  * Remove debian/kupfer.py, debian/install and stop overriding dh_fixperm in
    debian/rules: Upstream now provides entry points.

 -- Hugo Lefeuvre <hle@debian.org>  Tue, 04 Apr 2017 17:41:23 +0200

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders: Hugo Lefeuvre <hle@debian.org>
Build-Depends: debhelper (>= 11)
Build-Depends-Indep: gettext,
                     gnome-doc-utils,
                     intltool,
                     python3-all,
                     python3-docutils,
                     dh-python
Standards-Version: 4.1.5
Homepage: https://kupferlauncher.github.io/
Vcs-Git: https://salsa.debian.org/python-team/applications/kupfer.git
Vcs-Browser: https://salsa.debian.org/python-team/applications/kupfer

Package: kupfer
Architecture: all
Depends: python3-dbus,
         python3-xdg,
         python3-gi-cairo,
         gir1.2-gtk-3.0,
         gir1.2-keybinder-3.0,
         ${misc:Depends},
         ${python3:Depends}
Recommends: yelp, python3-wnck (>= 3.20)
Suggests: python3-setproctitle, gir1.2-appindicator3-0.1
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 .
 Kupfer is written in Python 3 and has a flexible architecture based on plugins
 to extend its features.

## kupfer 0%2Bv320

=== debian/changelog ===
kupfer (0+v320-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.1.
  * d/control: Update Maintainer field with new Debian Python Team
    contact address.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

  [ Debian Janitor ]
  * Add missing build dependency on dh addon.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Hugo Lefeuvre ]
  * New upstream release.
    - Use itstool instead of xml2po.
  * debian/watch: Point to new upstream repo, use version=4.
  * debian/control: Build-Depend on itstool and not deprecated
    gnome-doc-utils (Closes: #947533).
  * debian/rules: use --no-hooks

 -- Hugo Lefeuvre <hle@debian.org>  Sun, 25 Oct 2020 14:50:07 +0000

kupfer (0+v319-5) unstable; urgency=medium

  * Fix ayatana patch: misplaced else block leads to AppIndicator3 being
    systematically imported when AyatanaAppIndicator3 is available.

 -- Hugo Lefeuvre <hle@debian.org>  Thu, 08 Aug 2019 10:40:15 +0200

kupfer (0+v319-4) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.

  [ Hugo Lefeuvre ]
  * Switch to Ayatana AppIndicator (Closes: #906043):
    - Patch by Mike Gabriel, thanks!
    - debian/patches: Add ayatana-appindicator.patch.
    - debian/control: Prefer building against Ayatana AppIndicator shared lib.
    - Additionally provide 16x16 application icon, fixes display problem when
      kupfer is used in AppIndicator mode on i3 (which lacks AppIndicator and
      triggers the fallback GtkStatusIcon code in AppIndicator).
  * debian/control:
    - Bump Standards-Version to 4.4.0.
    - Depend on debhelper dependency to 12.
    - Remove non existing binary dependency python3-wnck.
    - Instead recommend gir1.2-wnck-3.0 (Closes: #876754).
  * debian/copyright:
    - Update copyright years.
  * Run wrap-and-sort -a.

 -- Hugo Lefeuvre <hle@debian.org>  Sun, 04 Aug 2019 13:40:25 +0200

## kupfer 0+c10

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import os
import sys
import Configure
import Utils

# the following two variables are used by the target "waf dist"
APPNAME="kupfer"
VERSION = "undefined"

def _get_git_version():
	""" try grab the current version number from git"""
	version = None
	if os.path.exists(".git"):
		try:
			version = os.popen("git describe").read().strip()
		except Exception, e:
			print e
	return version

def _read_git_version():
	"""Read version from git repo, or from GIT_VERSION"""
	version = _get_git_version()
	if not version and os.path.exists("GIT_VERSION"):
		f = open("GIT_VERSION", "r")
		version = f.read().strip()
		f.close()
	if version:
		global VERSION
		VERSION = version

_read_git_version()

VERSION_MAJOR_MINOR = ".".join(VERSION.split(".")[0:2])

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'

def dist_hook():
	"""in the dist preparation dir, delete unwanted files"""
	DIST_GIT_IGNORE = """
		debug.py
		makedist.sh
		""".split()

	for ignfile in filter(os.path.exists, DIST_GIT_IGNORE):
		os.unlink(ignfile)

def dist():
	"""Make the dist tarball and print its SHA-1 """
	def write_git_version():
		""" Write the revision to a file called GIT_VERSION,
		to grab the current version number from git when
		generating the dist tarball."""
		version = _get_git_version()
		if not version:
			return False
		version_file = open("GIT_VERSION", "w")
		version_file.write(version + "\n")
		version_file.close()
		return True

	import Scripting
	write_git_version()
	Scripting.g_gz = "gz"
	Scripting.dist(APPNAME, VERSION)

def set_options(opt):
	# options for disabling pyc or pyo compilation
	opt.tool_options("python")
	opt.tool_options("misc")
	opt.tool_options("gnu_dirs")

def configure(conf):
	conf.check_tool("python")
	conf.check_python_version((2,5,0))
	conf.check_tool("misc gnu_dirs")

	# BUG: intltool requires gcc
	conf.check_tool("gcc intltool")

	python_modules = """
		gio
		gtk
		xdg
		dbus
		"""
	for module in python_modules.split():
		conf.check_python_module(module)

	Utils.pprint("NORMAL", "Checking optional dependencies:")

	opt_programs = ["dbus-send"]
	opt_pymodules = "wnck gnome.ui".split()
	for prog in opt_programs:
		prog_path = conf.find_program(prog)

	try:
		conf.check_python_module("keybinder")
	except Configure.ConfigurationError, e:
		Utils.pprint("RED", "Python module keybinder is recommended")
		Utils.pprint("RED", "Please see README")
		
	for mod in opt_pymodules:
		try:
			conf.check_python_module(mod)
		except Configure.ConfigurationError, e:
			Utils.pprint("YELLOW", "python module %s is recommended" % mod)

	conf.env["KUPFER"] = Utils.subst_vars("${BINDIR}/kupfer", conf.env)
	conf.env["VERSION"] = VERSION

	# Check sys.path
	Utils.pprint("NORMAL", "Installing python modules into: %(PYTHONDIR)s" % conf.env)
	pipe = os.popen("""%(PYTHON)s -c "import sys; print '%(PYTHONDIR)s' in sys.path" """ % conf.env)
	if "False" in pipe.read():
		Utils.pprint("YELLOW", "Please add %(PYTHONDIR)s to your sys.path!" % conf.env)

def new_module(bld, name, sources=None):
	if not sources: sources = name
	obj = bld.new_task_gen("py")
	obj.find_sources_in_dirs(sources)
	obj.install_path = "${PYTHONDIR}/%s" % name
	return obj

def build(bld):
	# kupfer module version info file
	version_subst_file = "kupfer/version_subst.py"
	obj = bld.new_task_gen("subst",
		source=version_subst_file + ".in",
		target=version_subst_file,
		install_path="${PYTHONDIR}/kupfer",
		dict = bld.env,
		)

	# modules
	new_module(bld, "kupfer")
	new_module(bld, "kupfer/plugin")

	# binary
	# Subst in the python version
	# We have to put this in an intermediate build directory,
	# inside data/ not to clash with the 'kupfer' module(!)
	binary_subst_file = "kupfer-activate.sh"
	bin = bld.new_task_gen("subst",
		source = binary_subst_file,
		target = "data/kupfer",
		install_path = "${BINDIR}",
		chmod = 0755,
		dict = {"PYTHON": bld.env["PYTHON"]}
		)

	bld.add_subdirs("po data")

def intlupdate(util):
	"""Extract new strings for localization"""
	os.popen("intltool-extract --type=gettext/glade data/preferences.ui")
	os.chdir("po")
	for line in open("LINGUAS"):
		""" Run xgettext for all listed languages
		to extract translatable strings and merge with
		the old file """
		if line.startswith("#"):
			continue
		lang = line.strip()

		lang_file = "%s.po" % lang
		if not os.path.exists(lang_file):
			print "Creating %s" % lang_file
			os.popen("xgettext -D .. -f POTFILES.in --output=%s -F" % lang_file)
		print "Processing", lang
		os.popen("intltool-update %s" % lang)

def shutdown():
	pass

## kupfer 0+pb1.1

=== wscript ===
--- 
+++ 
@@ -4,6 +4,7 @@
 import os
 import sys
 import Configure
+import Options
 import Utils
 
 # the following two variables are used by the target "waf dist"
@@ -73,6 +74,14 @@
 	opt.tool_options("python")
 	opt.tool_options("misc")
 	opt.tool_options("gnu_dirs")
+	opt.add_option('--nopyo',action='store_false',default=False,help='Do not install optimised compiled .pyo files [This is the default for Kupfer]',dest='pyo')
+	opt.add_option('--pyo',action='store_true',default=False,help='Install optimised compiled .pyo files [Default:not install]',dest='pyo')
+	opt.add_option('--no-runtime-deps',action='store_false',default=True,
+			help='Do not check for any runtime dependencies',dest='check_deps')
+	opt.add_option('--pythondir-install',action='store_true',default=False,
+			help="Install Kupfer's modules as standard python modules [Default: Install into DATADIR]",
+			dest='pythondir_install')
+	opt.sub_options("extras")
 
 def configure(conf):
 	conf.check_tool("python")
@@ -81,6 +90,18 @@
 
 	# BUG: intltool requires gcc
 	conf.check_tool("gcc intltool")
+
+	conf.env["KUPFER"] = Utils.subst_vars("${BINDIR}/kupfer", conf.env)
+	conf.env["VERSION"] = VERSION
+	conf.sub_config("extras")
+
+	if not Options.options.pythondir_install:
+		conf.env["PYTHONDIR"] = Utils.subst_vars("${DATADIR}/kupfer", conf.env)
+	Utils.pprint("NORMAL",
+			"Installing python modules into: %(PYTHONDIR)s" % conf.env)
+
+	if not Options.options.check_deps:
+		return
 
 	python_modules = """
 		gio
@@ -93,10 +114,20 @@
 
 	Utils.pprint("NORMAL", "Checking optional dependencies:")
 
-	opt_programs = ["dbus-send"]
-	opt_pymodules = "wnck gnome.ui".split()
+	opt_programs = {
+			"dbus-send": "Focus kupfer from the command line",
+			"rst2man": "Generate and install man page",
+		}
+	opt_pymodules = {
+			"wnck": "Identify and focus running applications",
+			"gnome": ("Log out cleanly with session managers *OTHER* than "
+				"gnome-session >= 2.24"),
+		}
+
 	for prog in opt_programs:
-		prog_path = conf.find_program(prog)
+		prog_path = conf.find_program(prog, var=prog.replace("-", "_").upper())
+		if not prog_path:
+			Utils.pprint("YELLOW", "Optional, allows: %s" % opt_programs[prog])
 
 	try:
 		conf.check_python_module("keybinder")
@@ -108,37 +139,49 @@
 		try:
 			conf.check_python_module(mod)
 		except Configure.ConfigurationError, e:
-			Utils.pprint("YELLOW", "python module %s is recommended" % mod)
-
-	conf.env["KUPFER"] = Utils.subst_vars("${BINDIR}/kupfer", conf.env)
-	conf.env["VERSION"] = VERSION
-
-	# Check sys.path
-	Utils.pprint("NORMAL", "Installing python modules into: %(PYTHONDIR)s" % conf.env)
-	pipe = os.popen("""%(PYTHON)s -c "import sys; print '%(PYTHONDIR)s' in sys.path" """ % conf.env)
-	if "False" in pipe.read():
-		Utils.pprint("YELLOW", "Please add %(PYTHONDIR)s to your sys.path!" % conf.env)
-
-def new_module(bld, name, sources=None):
-	if not sources: sources = name
+			Utils.pprint("YELLOW", "module %s is recommended, allows %s" % (
+				mod, opt_pymodules[mod]))
+
+
+def _new_package(bld, name):
+	"""Add module @name to sources to be installed,
+	where the name is the full (relative) path to the package
+	"""
 	obj = bld.new_task_gen("py")
-	obj.find_sources_in_dirs(sources)
+	obj.find_sources_in_dirs(name)
 	obj.install_path = "${PYTHONDIR}/%s" % name
 	return obj
 
+def _find_packages_in_directory(bld, name):
+	"""Go through directory @name and recursively add all
+	Python packages with contents to the sources to be installed
+	"""
+	for dirname, dirs, filenames in os.walk(name):
+		if "__init__.py" in filenames:
+			_new_package(bld, dirname)
+
+def _dict_slice(D, keys):
+	return dict((k,D[k]) for k in keys)
+
 def build(bld):
+	# always read new version
+	bld.env["VERSION"] = VERSION
 	# kupfer module version info file
 	version_subst_file = "kupfer/version_subst.py"
 	obj = bld.new_task_gen("subst",
 		source=version_subst_file + ".in",
 		target=version_subst_file,
 		install_path="${PYTHONDIR}/kupfer",
-		dict = bld.env,
-		)
-
-	# modules
-	new_module(bld, "kupfer")
-	new_module(bld, "kupfer/plugin")
+		dict = _dict_slice(bld.env,"VERSION DATADIR PACKAGE LOCALEDIR".split())
+		)
+
+	obj = bld.new_task_gen(
+		source="kupfer.py",
+		install_path="${PYTHONDIR}"
+		)
+
+	# Add all Python packages recursively
+	_find_packages_in_directory(bld, "kupfer")
 
 	# binary
 	# Subst in the python version
@@ -150,29 +193,51 @@
 		target = "data/kupfer",
 		install_path = "${BINDIR}",
 		chmod = 0755,
-		dict = {"PYTHON": bld.env["PYTHON"]}
-		)
-
-	bld.add_subdirs("po data")
+		dict = _dict_slice(bld.env, "PYTHON PYTHONDIR".split())
+		)
+	# Documentation
+	if bld.env["RST2MAN"]:
+		# generate man page from Quickstart.rst
+		bld.new_task_gen(
+			source = "Documentation/Quickstart.rst",
+			target = "kupfer.1",
+			rule = 'rst2man ${SRC} > ${TGT}',
+		)
+		bld.add_group()
+		# compress and install man page
+		bld.new_task_gen(
+			source = "kupfer.1",
+			target = "kupfer.1.gz",
+			rule = 'gzip -c ${SRC} > ${TGT}',
+			install_path = "${MANDIR}/man1",
+		)
+
+	bld.add_subdirs("po data extras")
 
 def intlupdate(util):
-	"""Extract new strings for localization"""
-	os.popen("intltool-extract --type=gettext/glade data/preferences.ui")
-	os.chdir("po")
-	for line in open("LINGUAS"):
-		""" Run xgettext for all listed languages
-		to extract translatable strings and merge with
-		the old file """
-		if line.startswith("#"):
-			continue
-		lang = line.strip()
-
-		lang_file = "%s.po" % lang
-		if not os.path.exists(lang_file):
-			print "Creating %s" % lang_file
-			os.popen("xgettext -D .. -f POTFILES.in --output=%s -F" % lang_file)
-		print "Processing", lang
-		os.popen("intltool-update %s" % lang)
+	print "You should use intltool-update directly."
+	print "You can read about this in Documentation/Manual.rst"
+	print "in the localization chapter!"
+
+def test(bld):
+	# find all files with doctests
+	python = os.getenv("PYTHON", "python")
+	paths = os.popen("grep -lR 'doctest.testmod()' kupfer/").read().split()
+	os.putenv("PYTHONPATH", ".")
+	all_success = True
+	verbose = ("-v" in sys.argv)
+	for p in paths:
+		print p
+		cmd = [python, p]
+		if verbose:
+			cmd.append("-v")
+		sin, souterr = os.popen4(cmd)
+		sin.close()
+		res = souterr.read()
+		souterr.close()
+		print (res or "OK")
+		all_success = all_success and bool(res)
+	return all_success
 
 def shutdown():
 	pass

=== debian/changelog ===
kupfer (0+pb1.1-1ubuntu1) lucid; urgency=low

  * Use internal copy of waf.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Sat, 27 Feb 2010 15:11:23 +0100

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Luca Falavigna <dktrkranz@debian.org>
Uploaders: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7.0.50)
Build-Depends-Indep: python-support (>= 0.5.3), python (>= 2.5), gettext, intltool, python-docutils
Standards-Version: 3.8.4
XS-Python-Version: >= 2.5
Homepage: http://kaizer.se/wiki/kupfer/
Vcs-Svn: svn://svn.debian.org/python-apps/packages/kupfer/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/python-apps/packages/kupfer/trunk/

Package: kupfer
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-gobject (>= 2.18), python-gtk2 (>= 2.14), python-xdg, python-dbus, dbus, python-keybinder
Recommends: python-gnome2, python-wnck
Suggests: python-cjson, python-nautilus
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 . 
 Kupfer is written in Python and has a flexible architecture based on plugins
 to extend its features.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

clean:
	./waf distclean
	rm -fr build
	dh $@

override_dh_auto_configure:
	PYTHONDIR=/usr/share/kupfer ./waf configure --prefix=/usr --bindir=/usr/share/kupfer --no-runtime-deps

override_dh_auto_install:
	./waf install --nopyc --nopyo --destdir=$(CURDIR)/debian/kupfer
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/art/COPYING
	rst2html Documentation/Manual.rst build/manual.html
	rst2man Documentation/Quickstart.rst build/kupfer.1

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_fixperms:
	dh_fixperms
	chmod +x debian/kupfer/usr/share/kupfer/kupfer.py

=== debian/watch ===
version=3
opts=uversionmangle=s/^/0\+pb/ \
http://kaizer.se/publicfiles/kupfer/kupfer-pandoras-box-([0-9.]+)\.tar\.gz

## kupfer 0+v201

=== wscript ===
--- 
+++ 
@@ -1,5 +1,8 @@
 #! /usr/bin/env python
 # encoding: utf-8
+
+# Kupfer's main wscript description file for Waf, written by Ulrik Sverdrup
+# may be distributed, changed, used, etc freely for any purpose
 
 import os
 import sys
@@ -32,42 +35,66 @@
 		global VERSION
 		VERSION = version
 
+def _write_git_version():
+	""" Write the revision to a file called GIT_VERSION,
+	to grab the current version number from git when
+	generating the dist tarball."""
+	version = _get_git_version()
+	if not version:
+		return False
+	version_file = open("GIT_VERSION", "w")
+	version_file.write(version + "\n")
+	version_file.close()
+	return True
+
+
 _read_git_version()
-
-VERSION_MAJOR_MINOR = ".".join(VERSION.split(".")[0:2])
 
 # these variables are mandatory ('/' are converted automatically)
 srcdir = '.'
 blddir = 'build'
 
-def dist_hook():
-	"""in the dist preparation dir, delete unwanted files"""
-	DIST_GIT_IGNORE = """
-		debug.py
-		makedist.sh
-		""".split()
-
-	for ignfile in filter(os.path.exists, DIST_GIT_IGNORE):
-		os.unlink(ignfile)
+config_subdirs = "auxdata extras help"
+build_subdirs = "auxdata data po extras help"
+
+EXTRA_DIST = [
+	"waf",
+	"GIT_VERSION",
+]
+
+def _tarfile_append_as(tarname, filename, destname):
+	import tarfile
+	tf = tarfile.TarFile.open(tarname, "a")
+	try:
+		tf.add(filename, destname)
+	finally:
+		tf.close()
+
+def gitdist(ctx):
+	"""Make the release tarball using git-archive"""
+	import subprocess
+	if not _write_git_version():
+		raise Exception("No version")
+	basename = "%s-%s" % (APPNAME, VERSION)
+	outname = basename + ".tar"
+	proc = subprocess.Popen(
+		["git", "archive", "--format=tar", "--prefix=%s/" % basename, "HEAD"],
+		stdout=subprocess.PIPE)
+	fd = os.open(outname, os.O_CREAT | os.O_EXCL | os.O_WRONLY, 0666)
+	os.write(fd, proc.communicate()[0])
+	os.close(fd)
+	for distfile in EXTRA_DIST:
+		_tarfile_append_as(outname, distfile, os.path.join(basename, distfile))
+	subprocess.call(["gzip", outname])
+	subprocess.call(["sha1sum", outname + ".gz"])
 
 def dist():
-	"""Make the dist tarball and print its SHA-1 """
-	def write_git_version():
-		""" Write the revision to a file called GIT_VERSION,
-		to grab the current version number from git when
-		generating the dist tarball."""
-		version = _get_git_version()
-		if not version:
-			return False
-		version_file = open("GIT_VERSION", "w")
-		version_file.write(version + "\n")
-		version_file.close()
-		return True
-
+	"The standard waf dist process"
 	import Scripting
-	write_git_version()
+	_write_git_version()
 	Scripting.g_gz = "gz"
 	Scripting.dist(APPNAME, VERSION)
+
 
 def set_options(opt):
 	# options for disabling pyc or pyo compilation
@@ -78,14 +105,19 @@
 	opt.add_option('--pyo',action='store_true',default=False,help='Install optimised compiled .pyo files [Default:not install]',dest='pyo')
 	opt.add_option('--no-runtime-deps',action='store_false',default=True,
 			help='Do not check for any runtime dependencies',dest='check_deps')
-	opt.add_option('--pythondir-install',action='store_true',default=False,
-			help="Install Kupfer's modules as standard python modules [Default: Install into DATADIR]",
-			dest='pythondir_install')
-	opt.sub_options("extras")
+	opt.sub_options(config_subdirs)
 
 def configure(conf):
 	conf.check_tool("python")
-	conf.check_python_version((2,5,0))
+	try:
+		conf.check_python_version((2,6,0))
+	except Configure.ConfigurationError:
+		# with explicitly set python that is not found, we
+		# must show an error
+		if os.getenv("PYTHON"):
+			raise
+		conf.env["PYTHON"] = "python2.6"
+		conf.check_python_version((2,6,0))
 	conf.check_tool("misc gnu_dirs")
 
 	# BUG: intltool requires gcc
@@ -93,10 +125,10 @@
 
 	conf.env["KUPFER"] = Utils.subst_vars("${BINDIR}/kupfer", conf.env)
 	conf.env["VERSION"] = VERSION
-	conf.sub_config("extras")
-
-	if not Options.options.pythondir_install:
-		conf.env["PYTHONDIR"] = Utils.subst_vars("${DATADIR}/kupfer", conf.env)
+	conf.sub_config(config_subdirs)
+
+	# Setup PYTHONDIR so we install into $DATADIR
+	conf.env["PYTHONDIR"] = Utils.subst_vars("${DATADIR}/kupfer", conf.env)
 	Utils.pprint("NORMAL",
 			"Installing python modules into: %(PYTHONDIR)s" % conf.env)
 
@@ -108,6 +140,7 @@
 		gtk
 		xdg
 		dbus
+		keyring
 		"""
 	for module in python_modules.split():
 		conf.check_python_module(module)
@@ -150,7 +183,19 @@
 	obj = bld.new_task_gen("py")
 	obj.find_sources_in_dirs(name)
 	obj.install_path = "${PYTHONDIR}/%s" % name
-	return obj
+
+	# Find embedded package datafiles
+	pkgnode = bld.path.find_dir(name)
+	bld.rescan(pkgnode)
+
+	def is_datafile(fname):
+		if fname in ["icon-list"]:
+			return True
+		return os.path.splitext(fname)[-1] in set([".png", ".svg"])
+
+	for dfile in filter(is_datafile, bld.cache_dir_contents[pkgnode.id]):
+		bld.install_files(obj.install_path,
+				"%s/%s" % (pkgnode.abspath(), dfile))
 
 def _find_packages_in_directory(bld, name):
 	"""Go through directory @name and recursively add all
@@ -166,6 +211,8 @@
 def build(bld):
 	# always read new version
 	bld.env["VERSION"] = VERSION
+
+	# kupfer/
 	# kupfer module version info file
 	version_subst_file = "kupfer/version_subst.py"
 	obj = bld.new_task_gen("subst",
@@ -183,19 +230,24 @@
 	# Add all Python packages recursively
 	_find_packages_in_directory(bld, "kupfer")
 
-	# binary
-	# Subst in the python version
-	# We have to put this in an intermediate build directory,
-	# inside data/ not to clash with the 'kupfer' module(!)
-	binary_subst_file = "kupfer-activate.sh"
-	bin = bld.new_task_gen("subst",
-		source = binary_subst_file,
-		target = "data/kupfer",
+	# bin/
+	# Write in some variables in the shell script binaries
+	bld.new_task_gen("subst",
+		source = "bin/kupfer.in",
+		target = "bin/kupfer",
 		install_path = "${BINDIR}",
 		chmod = 0755,
 		dict = _dict_slice(bld.env, "PYTHON PYTHONDIR".split())
 		)
-	# Documentation
+	bld.new_task_gen("subst",
+		source = "bin/kupfer-exec.in",
+		target = "bin/kupfer-exec",
+		install_path = "${BINDIR}",
+		chmod = 0755,
+		dict = _dict_slice(bld.env, "PACKAGE LOCALEDIR".split())
+		)
+
+	# Documentation/
 	if bld.env["RST2MAN"]:
 		# generate man page from Quickstart.rst
 		bld.new_task_gen(
@@ -205,14 +257,19 @@
 		)
 		bld.add_group()
 		# compress and install man page
-		bld.new_task_gen(
+		manpage = bld.new_task_gen(
 			source = "kupfer.1",
 			target = "kupfer.1.gz",
-			rule = 'gzip -c ${SRC} > ${TGT}',
+			rule = 'gzip -9 -c ${SRC} > ${TGT}',
 			install_path = "${MANDIR}/man1",
 		)
-
-	bld.add_subdirs("po data extras")
+		man_path = Utils.subst_vars(
+				os.path.join(manpage.install_path, manpage.target),
+				bld.env)
+		bld.symlink_as("${MANDIR}/man1/kupfer-exec.1.gz", man_path)
+
+	# Separate subdirectories
+	bld.add_subdirs(build_subdirs)
 
 def intlupdate(util):
 	print "You should use intltool-update directly."

=== auxdata/wscript ===
#! /usr/bin/env python

import Options
import Utils

def set_options(opt):
	opt.add_option('--no-update-mime',
			action='store_true',
			default=False,
			help='Do not update mime and desktop databases [Default:Update]')

def configure(conf):
	if not Options.options.no_update_mime:
		conf.env["AUXDATA_MIME"] = 1


def build(bld):
	# merge translations into the .desktop file
	# and set it up to be installed
	def install_desktop_file(desktop_subst_file):
		bld.new_task_gen(
			"intltool_in",
			podir="../po",
			flags = ("-d", "-q", "-u", "-c"),
			source = desktop_subst_file  + ".in",
			target = desktop_subst_file,
			install_path = "${DATADIR}/applications",
			chmod = 0755,
		)

	install_desktop_file("kupfer.desktop")
	install_desktop_file("kupfer-exec.desktop")

	# install mimetype descriptions

	mimetypes_file = "kupfer-mimetypes.xml"
	bld.new_task_gen(
		"intltool_in",
		podir="../po",
		flags = ("-x", "-q", "-u", "-c"),
		source = mimetypes_file  + ".in",
		target = mimetypes_file,
		install_path = "${DATADIR}/mime/packages/",
	)

	if bld.is_install and bld.env["AUXDATA_MIME"]:
		bld.exec_command(["update-mime-database",
				Utils.subst_vars("${DATADIR}/mime", bld.env)])
		bld.exec_command(["update-desktop-database",
				Utils.subst_vars("${DATADIR}/applications", bld.env)])

	icons_inst = bld.install_files("${DATADIR}/icons/hicolor/scalable/apps",
	                               "kupfer.svg")

	# Waf's "gnome" tool  -- def postinstall_icons():
	if icons_inst and bld.is_install:
		icon_dir = bld.get_install_path('${DATADIR}/icons/hicolor')
		if not Options.options.destdir:
			Utils.pprint('YELLOW',"Updating Gtk icon cache.")
			command='gtk-update-icon-cache -q -f -t %s' % icon_dir
			ret=Utils.exec_command(command)
		else:
			Utils.pprint('YELLOW','Icon cache not updated. After install, run this:')
			Utils.pprint('YELLOW','gtk-update-icon-cache -q -f -t %s'%icon_dir)

=== extras/wscript ===
import Options, Utils
import os

def set_options(opt):
	opt.add_option('--no-install-nautilus-extension',
			action='store_true',
			default=False,
			help='Install Kupfer Nautilus Extension [Default:Install]')

def configure(conf):
	if Options.options.no_install_nautilus_extension:
		return
	libdir = Utils.subst_vars("${LIBDIR}", conf.env)
	if libdir.startswith(os.path.expanduser("~/")):
		NAUTILUS_EXT_LIBDIR=os.path.expanduser("~/.nautilus/python-extensions/")
	else:
		NAUTILUS_EXT_LIBDIR=os.path.join(libdir, "nautilus", "extensions-2.0",
				"python")
	conf.env["NAUTILUS_EXT_LIBDIR"] = NAUTILUS_EXT_LIBDIR

def build(bld):
	if not bld.env["NAUTILUS_EXT_LIBDIR"]:
		return
	bld.install_files("${NAUTILUS_EXT_LIBDIR}", "kupfer_provider.py")

=== help/wscript ===
#!/usr/bin/env python

# Mallard waf adaptor written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

## Mallard functionality definitions ##
import os
import Task
import TaskGen

# FIXME: Support for figures

def _read_makefile_am(filename):
	"read a Makefile.am file for DOC_* variable definitions, return a dict"
	varstring = open(filename).read()
	varstring = varstring.replace("\\\n", " ")
	varlines = [L for L in varstring.splitlines() if L.startswith("DOC")]
	return dict(tuple(map(str.strip, var.split("=", 1))) for var in varlines)

def init_mallard(self):
	mf_am = self.path.find_resource(self.variable_definitions)
	DOC_VAR = _read_makefile_am(mf_am.abspath())

	require_vars = "DOC_ID DOC_LINGUAS DOC_PAGES".split()
	have_vars = set(var for var in DOC_VAR if DOC_VAR[var])
	missing_vars = set(require_vars).difference(have_vars)
	if missing_vars:
		print "Missing DOC variable declarations in %s:" % (mf_am.abspath())
		print "\n".join(missing_vars)

	self.bld.env.update(DOC_VAR)
	self.default_install_path='${PREFIX}/share/gnome/help/${DOC_ID}'

def apply_mallard(self):
	bld = self.bld
	lst = self.to_list(bld.env["DOC_LINGUAS"])
	cnode = self.path.find_dir("C")
	self.bld.rescan(cnode)

	pages = [p for p in self.bld.cache_dir_contents[cnode.id]
			if (os.path.splitext(p)[-1].lower()) == ".page"]

	# Check if the declared page list is consistent
	declared_pages = self.to_list(bld.env["DOC_PAGES"])
	missing_pages = set(pages).difference(declared_pages)
	if missing_pages:
		print "Warning: Some pages not declared:"
		print "\n".join(missing_pages)

	for lang in lst:
		node = self.path.find_resource("%s/%s.po" % (lang, lang))
		for page in pages:
			tsk = self.create_task('xml2po')
			out = self.path.find_or_declare('%s/%s' % (lang, page))
			src = self.path.find_resource('C/%s' % page)
			tsk.set_inputs([node,src])
			tsk.set_outputs(out)
			tsk.install_path = os.path.join(self.install_path, lang)
	if bld.is_install:
		for page in pages:
			out = "%s/%s" % (cnode.abspath(), page)
			instdir = os.path.join(self.install_path, "C")
			bld.install_files(instdir, out)

Task.simple_task_type('xml2po', '${XML2PO} ${XML2POFLAGS} ${SRC} > ${TGT}',
		color='BLUE')

TaskGen.feature("mallard")(init_mallard)
TaskGen.feature("mallard")(apply_mallard)
TaskGen.after('init_mallard')(apply_mallard)

## End Mallard functionality ##


# Build Configuration

def set_options(opt):
	pass

def configure(conf):
	xml2po = conf.find_program('xml2po', var='XML2PO')
	conf.env['XML2POFLAGS'] = '-mmallard -p'

def build(bld):
	if bld.env["XML2PO"]:
		task = bld.new_task_gen(
			features="mallard",
			variable_definitions="Makefile.am",
		)

=== help/C/Makefile ===
pages=$(wildcard *.page)
htmls=$(patsubst %.page,%.html,$(pages))

all: $(htmls) index.cache

index.cache : $(pages)
	echo '<cache xmlns="http://projectmallard.org/1.0/">' > $@.in
	for page in $(pages); do \
	  echo "<page href='$$page'/>" >> $@.in; \
	done
	echo '</cache>' >> $@.in
	xsltproc `pkg-config --variable xsltdir gnome-doc-utils`/mallard/utils/mal2cache.xsl $@.in | xmllint --format - > $@
	rm $@.in

$(htmls) : index.cache
$(htmls) : %.html : %.page
	xsltproc \
	  --stringparam mal.cache.file `pwd`/index.cache \
	  --param mal.chunk.chunk_top 1 \
	  `pkg-config --variable mal2html gnome-doc-utils` $<

.PHONY: clean
clean:
	rm index.cache *.html

=== debian/changelog ===
kupfer (0+v201-2+squeeze2) stable; urgency=low

  * debian/patches/evolution_contacts.patch:
    - Do not crash if Evolution address book is missing (Closes: #632933).

 -- Luca Falavigna <dktrkranz@debian.org>  Fri, 08 Jul 2011 19:39:20 +0200

kupfer (0+v201-2+squeeze1) stable; urgency=low

  * debian/patches/TYPE_UINT.patch:
    - Backport a fix from upstream git repository, use UINT signal
      parameter type to fix an issue with ui.keybindings (Closes: #615060).

 -- Luca Falavigna <dktrkranz@debian.org>  Thu, 14 Apr 2011 22:26:38 +0200

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Luca Falavigna <dktrkranz@debian.org>
Uploaders: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7.0.50)
Build-Depends-Indep: python-support, python (>= 2.6), gettext, intltool, python-docutils
Standards-Version: 3.9.0
XS-Python-Version: >= 2.6
Homepage: http://kaizer.se/wiki/kupfer/
Vcs-Svn: svn://svn.debian.org/python-apps/packages/kupfer/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/python-apps/packages/kupfer/trunk/

Package: kupfer
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-gobject (>= 2.18), python-gtk2 (>= 2.16), python-xdg, python-dbus, dbus, python-keyring, python-keybinder
Recommends: python-gnome2, python-wnck, python-keyring-gnome
Suggests: python-cjson, python-nautilus
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 . 
 Kupfer is written in Python and has a flexible architecture based on plugins
 to extend its features.

=== debian/rules ===
--- 
+++ 
@@ -23,4 +23,3 @@
 override_dh_fixperms:
 	dh_fixperms
 	chmod +x debian/kupfer/usr/share/kupfer/kupfer.py
-

## kupfer 0+v206

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Luca Falavigna <dktrkranz@debian.org>
Uploaders: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7.0.50~)
Build-Depends-Indep: python (>= 2.6.6-3~), gettext, intltool, gnome-doc-utils, python-docutils
Standards-Version: 3.9.2
X-Python-Version: >= 2.6
Homepage: http://kaizer.se/wiki/kupfer/
Vcs-Svn: svn://svn.debian.org/python-apps/packages/kupfer/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/python-apps/packages/kupfer/trunk/

Package: kupfer
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-gobject (>= 2.18), python-gtk2 (>= 2.16), python-xdg, python-dbus, dbus, python-keybinder
Recommends: python-keyring, python-wnck
Suggests: python-cjson, python-gdata
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 . 
 Kupfer is written in Python and has a flexible architecture based on plugins
 to extend its features.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

clean:
	./waf distclean
	rm -fr build
	dh $@ Documentation/*.html

override_dh_auto_configure:
	PYTHONDIR=/usr/share/kupfer ./waf configure --prefix=/usr --nopyc --nopyo \
		--bindir=/usr/share/kupfer --no-runtime-deps --no-install-nautilus-extension

override_dh_auto_install:
	./waf install --destdir=$(CURDIR)/debian/kupfer
	install -m 0755 $(CURDIR)/build/bin/kupfer $(CURDIR)/debian/kupfer/usr/share/kupfer/kupfer-activate.sh
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/kupfer/kupfer
	rm -f $(CURDIR)/debian/kupfer/usr/share/gnome/help/kupfer/*/license.page
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/art/COPYING
	make -C Documentation
	rst2man Documentation/Manpage.rst build/kupfer.1

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_fixperms:
	dh_fixperms
	chmod +x debian/kupfer/usr/share/kupfer/kupfer.py
